<?php
header("content-type: text/html; charset=utf-8");
session_start();

include "logincheck.inc.php";
if (!$_SESSION['s_caninsert']) {
	$error_page_code = "permission";
	include "errorpage.php";
	exit();
}

include "languages.php";
include "config.php";
include_once "functions.inc.php";
include "attributes.php";
include_once "../languages/korean_workaround.inc.php";
include_once "../languages/taiwan_workaround.inc.php";
include_once "../languages/japanese_workaround.inc.php";
include_once "../languages/chinese_workaround.inc.php";

makeheader(READ_TITLE);
?>
<table cellpadding="1" cellspacing="0" border="0" align="center" width="90%"><tr class="firstcolor"><td>
<?php
if (isset($_FILES['userfile']) && !empty($_FILES['userfile']['name'])) {
	// Dateiupload behandeln
	include("javahelp.php");
} else {
	if (isset($_POST['gala']) && !empty($_POST['gala'])) {
		include_once "spioparser.inc.php";
		$contents = $_POST['gala'];
		
		if (strpos($contents,"itibariyle mevcut olan hammadde") !== false) {
			// old universe
			$contents = preg_replace("/(.*\s\[\d+\:\d+\:\d+\]\s+\(.*\)\s\w+\s+\d+\-\d+\s\d+:\d+:\d+\s)(itibariyle mevcut olan hammadde)/","$2 $1",$contents);
		}
		if (strpos($contents,"üzerinde bulunan hammaddeler") !== false) {
			// redesign
			$contents = preg_replace("/(\d+\-\d+\s\d+:\d+:\d+)\s+tarihinde\s(.+\s\[\d+\:\d+\:\d+\]\s\(.*\))\s+(üzerinde bulunan hammaddeler)/","$3 $2 de $1",$contents);
		}

		$contents = str_replace("Rohstoffe auf","Resources on",$contents); // German
		$contents = str_replace("Resources at","Resources on",$contents); // English changed from Resources on to Resources at
		$contents = str_replace("Recursos en","Resources on",$contents); // Spanish
		$contents = str_replace("Recursos em","Resources on",$contents); // Portugues + Brazilian
		$contents = str_replace("Recursos no","Resources on",$contents);
		$contents = str_replace("Grondstoffen op","Resources on",$contents); // Dutch
		$contents = str_replace("Sirovine na","Resources on",$contents); // Balkan
		$contents = str_replace("Matières premières sur","Resources on",$contents); // French
		$contents = str_replace("Ressources sur","Resources on",$contents); // French redesign
		$contents = str_replace("Surowce na","Resources on",$contents); // Polish
		$contents = str_replace("Risorse su","Resources on",$contents); // Italian
		$contents = str_replace("itibariyle mevcut olan hammadde","Resources on",$contents); // Turkish - old universe
		$contents = str_replace("üzerinde bulunan hammaddeler","Resources on",$contents); // Turkish - redesign
		$contents = str_replace("Råstoffer","Resources on",$contents); // Danish
		$contents = str_replace("Ressurcer på","Resources on",$contents); // Danish
		$contents = str_replace("Сырьё на","Resources on",$contents); // Russian
		$contents = str_replace("Πόροι στο","Resources on",$contents); // Greek
		$contents = str_replace("Resurser på","Resources on",$contents); // Swedish
		$contents = str_replace("Resursele pe","Resources on",$contents); // Romanian
		$contents = str_replace("Resurse la","Resources on",$contents); // Romanian redesign
		$contents = str_replace("Erőforrások a","Resources on",$contents); // Hungarian
		$contents = str_replace("Nyersanyagok itt:","Resources on",$contents); // Hungarian redesign
		$contents = str_replace("Suroviny na","Resources on",$contents); // Czech
		$contents = str_replace("Ressurser på","Resources on",$contents); // Norwegian
		$contents = str_replace("Ресирси на","Resources on",$contents); // Bulgarian
		$contents = str_replace("Ресурси на","Resources on",$contents); // Bulgarian redesign
		$contents = str_replace("Resursai","Resources on",$contents); // Lithuanian
		$contents = str_replace("Resursai","Resources on",$contents); // Lithuanian redesign
		$contents = str_replace("Resursi uz","Resources on",$contents); // Latvian
		$contents = str_replace("Resursų","Resources on",$contents); // Latvian redesign
		$contents = str_replace("Resurssit","Resources on",$contents); // Finnish
		$contents = str_replace("Zdroje na svete menom","Resources on",$contents); // Slovak
		$contents = str_replace("Zdroje na","Resources on",$contents); // Slovak redesign
		$contents = str_replace($taiwan_resources_on,"Resources on",$contents); // Taiwan
		$contents = str_replace("Resursi na planeti","Resources on",$contents); // Croatian
		$contents = str_replace("Resursi na","Resources on",$contents); // Croatian moons
		

		//$contents = preg_replace("/(\d+\-\d+\s\d+\:\d+\:\d+)(\s+Flottbefällhavare\s+Spionagerapport av\s+[\w\s\_\-]+\[\d+\:\d+\:\d+\])/","$2 $1",$contents); // Swedish
		//$contents = str_replace("Spionagerapport av","Resources on",$contents); // Swedish
		//$contents = str_replace("Resurser på","",$contents); // Swedish
		if (strpos($contents,$korean_resources_on) !== false) { // korean
			$contents = "Resources on ".$contents;
		}
		$contents = preg_replace($japan_resource_pattern,"Resources on $3 $4 at $1",$contents);

		// Reports
		if ($_SESSION['s_probeview'])	{
			// turkish version!
			if ($_SESSION['lang'] == "turkish") {
				$contents = str_replace("\r","",$contents);
				$tmp = explode("\n",$contents);
				$new = "";
				foreach ($tmp as $line) {
					if (strpos($line,"Resources on") !== false) {
						$line = str_replace("Resources on","",$line);
						$new .= "Resources on " . $line."\n";
					} else {
						$new .= $line."\n";
					}
				}
			}

			$spio_array = preg_split('/Resources on/',$contents,-1);

//			echo "<pre>";
//			print_r($spio_array);
//			echo "</pre>";

			$spioparser = new Probeparser($dbusername,$dbpassword,$dbname,$reporttable,$dbtablename,$playertable,$dbhost);
			for ($i=1;$i<count($spio_array);$i++) {
				if ($spioparser->parseEntry("Resources on".$spio_array[$i],$_SESSION['s_userid']) == false) {
					// error handling
					foreach ($spioparser->error as $error_entry) {
						if (is_array($error_entry)) {
							$error_text = implode(" ",$error_entry);
							echo "<div class=\"failure\">".REPORTS_UNKNOWN_ENTRIES.": ".$error_text."</div>";
						} else {
							echo "<div class=\"failure\">".$error_entry."</div>";
						}
					}
				}
			}
		} else {
			echo READ_PERMISSION."<br>";
		}
	}
	echo READ_JOB_DONE;
}

?>
</td></tr></table>

<form name="scans" method="post" action="einlesen.php" enctype="multipart/form-data" accept-charset="utf-8">
<table cellpadding="1" cellspacing="0" border="0" align="center" width="90%"><tr><td>
<table class="standard" cellpadding="4" cellspacing="0" border="0" width="100%">
<tr class="tblhead"><td colspan="2"><?php echo READ_TOPIC; ?></td></tr>
<tr class='firstcolor' valign='top'><td colspan='2'><?php echo READ_DESCRIPTION; ?></td></tr>
<tr class="firstcolor"><td><?php echo READ_GALAXY; ?></td>
<td><textarea class="textfield" name="gala" cols="65" rows="25"></textarea></td>
</tr>
<tr class="firstcolor"><td><?php echo READ_FILEUPLOAD; ?></td>
<td>
<input name="userfile" type="file" class="textfield">
</td>
</tr>
<tr class="firstcolor" valign="top">

	      	<td align="right"><input class="button" type="submit" name="<?php echo READ_BUTTON; ?>" value="<?php echo READ_BUTTON; ?>" /></td>

	      	<td><input class="button" type="reset" name="Reset" value="<?php echo USER_RESET; ?>" /></td>
</tr></table>
</td></tr>
</table>
</form>
<?php
makefooter();
?>
